/*
	CPU evaluate
	time-precision.c
		2001.04.13
*/

#include	<sys/times.h>
#include	<unistd.h>
#include	<stdio.h>
struct timeval	{
	long tv_sec;
	long tv_usec;
};
struct	timezone	{
	int	tz_minuteswest;
	int	tz_dstttime;
}

main (int argc, char **argv)
{
clock_t	tmscur;
struct tms tmsstart, tmscurrent;
int	timevalcur;
struct timeval	timevalstart;
struct timeval	timevalcurrent;
struct timezone	timezonestart, timezonecurrent;

	tmscur = times (&tmsstart);
	do	{
		tmscur = times (&tmscurrent);
	} while (tmsstart.tms_utime == tmscurrent.tms_utime && 
		tmsstart.tms_stime == tmscurrent.tms_stime);

	printf ("times: utime defference = %d\n", 
			tmscurrent.tms_utime - tmsstart.tms_utime);
	printf ("times: stime difference = %d\n",
			tmscurrent.tms_stime - tmsstart.tms_stime);
	
	timevalcur = gettimeofday (&timevalstart, &timezonestart);
	do	{
		timevalcur = gettimeofday (&timevalcurrent, &timezonecurrent);
	} while	(timevalstart.tv_sec == timevalcurrent.tv_sec && 
		timevalstart.tv_usec == timevalcurrent.tv_usec);
	printf ("gettimeofday : sec diffence = %d\n",
			timevalcurrent.tv_sec - timevalstart.tv_sec);
	printf ("gettimeofday : usec diffence = %d\n", 
			timevalcurrent.tv_usec - timevalstart.tv_usec);
}
